﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Diagnostics;

namespace HowDoISamples
{
    public partial class DisplayASimpleMap : UserControl
    {
        public DisplayASimpleMap()
        {
            InitializeComponent();
        }

        void DisplayASimpleMap_Load(object sender, EventArgs e)
        {
            // Setup the map control            
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.CurrentExtent = new RectangleShape(-16655494.6910373, -1985442.7464627, -16654458.2847873, -1986181.0277127);
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            // Create the TiledWmsOverlay and pass in the URL to the server
            // The ActiveLayerName needs to match the value you return in the GetNameCore of the plugin
            TiledWmsOverlay tiledWmsOverlay = new TiledWmsOverlay(new Uri("http://localhost:62626/WmsHandler.axd"));
            tiledWmsOverlay.TileCache = null;
            tiledWmsOverlay.ActiveLayerNames.Add("Tahiti");
            tiledWmsOverlay.ActiveStyleNames.Add("DEFAULT");
            winformsMap1.Overlays.Add("TiledWmsOverlay", tiledWmsOverlay);
            winformsMap1.Refresh();

        }

        #region Component Designer generated code

        /// <summary> 
        /// Required designer variable.
        /// </summary>
        private IContainer components = null;
        private Label lblDescription;
        private GroupBox gbInstruction;
        private WinformsMap winformsMap1;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.winformsMap1 = new ThinkGeo.MapSuite.DesktopEdition.WinformsMap();
            this.lblDescription = new System.Windows.Forms.Label();
            this.gbInstruction = new System.Windows.Forms.GroupBox();
            this.gbInstruction.SuspendLayout();
            this.SuspendLayout();
            // 
            // winformsMap1
            // 
            this.winformsMap1.BackColor = System.Drawing.Color.White;
            this.winformsMap1.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.Default;
            this.winformsMap1.CurrentScale = 590591790;
            this.winformsMap1.DrawingQuality = ThinkGeo.MapSuite.Core.DrawingQuality.Default;
            this.winformsMap1.Location = new System.Drawing.Point(0, 0);
            this.winformsMap1.MapFocusMode = ThinkGeo.MapSuite.DesktopEdition.MapFocusMode.Default;
            this.winformsMap1.MapResizeMode = ThinkGeo.MapSuite.Core.MapResizeMode.PreserveScale;
            this.winformsMap1.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.DecimalDegree;
            this.winformsMap1.MaximumScale = 80000000000000;
            this.winformsMap1.MinimumScale = 200;
            this.winformsMap1.Name = "winformsMap1";
            this.winformsMap1.Size = new System.Drawing.Size(737, 525);
            this.winformsMap1.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            this.winformsMap1.TabIndex = 0;
            this.winformsMap1.Text = "winformsMap1";
            this.winformsMap1.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            this.winformsMap1.ThreadingMode = ThinkGeo.MapSuite.DesktopEdition.MapThreadingMode.Default;
            this.winformsMap1.ZoomLevelSnapping = ThinkGeo.MapSuite.DesktopEdition.ZoomLevelSnappingMode.Default;
            // 
            // lblDescription
            // 
            this.lblDescription.BackColor = System.Drawing.Color.Transparent;
            this.lblDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.lblDescription.Location = new System.Drawing.Point(6, 12);
            this.lblDescription.Name = "lblDescription";
            this.lblDescription.Size = new System.Drawing.Size(237, 65);
            this.lblDescription.TabIndex = 10;
            this.lblDescription.Text = "This sample shows how to display a simple map using DisplayASimpleMapWmsPlugin.  " +
                "This plugin only uses the GetMapConfiguration so it is static.\r\n";
            this.lblDescription.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // gbInstruction
            // 
            this.gbInstruction.Controls.Add(this.lblDescription);
            this.gbInstruction.Location = new System.Drawing.Point(474, 3);
            this.gbInstruction.Name = "gbInstruction";
            this.gbInstruction.Size = new System.Drawing.Size(260, 85);
            this.gbInstruction.TabIndex = 11;
            this.gbInstruction.TabStop = false;
            this.gbInstruction.Text = "Instruction";
            // 
            // DisplayASimpleMap
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.Controls.Add(this.gbInstruction);
            this.Controls.Add(this.winformsMap1);
            this.Name = "DisplayASimpleMap";
            this.Size = new System.Drawing.Size(737, 528);
            this.Load += new System.EventHandler(this.DisplayASimpleMap_Load);
            this.gbInstruction.ResumeLayout(false);
            this.ResumeLayout(false);

        }

        #endregion
    }
}
