﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WmsServerEdition;

namespace PICTImageryPlugin
{
    public class TahitiPlugin : WmsLayerPlugin
    {
        public TahitiPlugin()
        {
            //this.WmsQueryMode = ThinkGeo.MapSuite.WmsServerEdition.WmsQueryMode.Queryable; 
        }

        // In this method you need to return the bounding box of the layer. 
        protected override RectangleShape GetBoundingBoxCore(string crs)
        {
            //crash - return new RectangleShape(-16657318.2682705, -1977400.70773863, -16599259.0555456, -2026028.99527003); 
            // return new RectangleShape(-20037508, 2725981, 20037508, -3623688); // wrap extent 
        //*****I got this extent by getBoundingBox.
            return new RectangleShape(-16655494.6910373, -1985442.7464627, -16654458.2847873, -1986181.0277127);

        }

        protected override MapConfiguration GetMapConfigurationCore(string style, string crs)
        {
            // Get the directory to the sample data 
            string worldLayerFilePath = @"C:\temp\Tahiti_lowres.jp2";

            BackgroundLayer backgroundLayer = new BackgroundLayer(new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean));

            Jpeg2000RasterLayer jp2 = new Jpeg2000RasterLayer(worldLayerFilePath);
            // Create a MapConfiguration and add the layer to it 
            MapConfiguration mapConfiguration = new MapConfiguration();
            mapConfiguration.Layers.Add("BackgroundLayer", backgroundLayer);
            mapConfiguration.Layers.Add("WorldLayer", jp2);
            return mapConfiguration;
        }

        // In this method you need to return the name of the Layer that WMS will expose. 
        // You will use this name on the client to specify the layer you want to consume 
        protected override string GetNameCore()
        {
            return "Tahiti";
        }

        protected override GeographyUnit GetGeographyUnitCore(string crs)
        {
            GeographyUnit geographyUnit = GeographyUnit.DecimalDegree;
            switch (crs)
            {
                case "EPSG:4326":
                    break;
                case "EPSG:900913":
                    geographyUnit = GeographyUnit.Meter;
                    break;
            }

            return geographyUnit;
        }

        // In this method you need to return the projections that are supported by your data. 
        // It is your responsability to project the data in the MapConfiguration for each projection 
        // type you specify here. 
        protected override Collection<string> GetProjectionsCore()
        {
        //*****return 4326 not 900913
            return new Collection<string> { "EPSG:4326" }; 
            //return new Collection<string> { "EPSG:900913" };
        }
    }
}